--[[
--                                           MOUNTY 2009 through 2015 or (c)2009 through 2015
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Function Library (to smooth transition when the Blizzard API changes)
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_SetStateVariables(State)
	State.IsMounted = false;
	State.IsFlying = false;
	local vehicle = false;
	local taxi = UnitOnTaxi("player");
	if taxi ~= 1 then
		if CanExitVehicle() then
			vehicle = true;
		end
		if IsMounted() or vehicle then
			State.IsMounted = true;
		end
		if IsFlying() then
			State.IsFlying = true;
		end
	end
	return vehicle;
end

function Mounty_CheckMountAura()
	local n, name = 1, "";
	local aura = nil;
	while (UnitAura("player", n)) do
		name = UnitAura("player", n);
		n= n+1;
		if (name == "Telaari Talbuk") then
			aura = name;
		elseif (name == "Frostwolf War Wolf") then
			aura = name;
		elseif (name == "Telaari Siege Engine") then
			aura = name;
		elseif (name == "Wor\'var Demolisher") then
			aura = name;
		end
	end
	return aura;
end
--[[
 1 = 13 (Kalimdor)
 2 = Kalimdor (Eastern Kingdoms)
 3 = 14 (Outland)
 4 = Eastern Kingdoms (Northrend)
 5 = 466 (The Maelstrom)
 6 = Outland (Pandaria)
 7 = 485 (Draenor)
 8 = Northrend
 9 = 751
10 = The Maelstrom
11 = 862
12 = Pandaria
13 = 962
14 = Draenor

	-1 - Cosmic map
    0 - Azeroth
    1 - Kalimdor
    2 - Eastern Kingdoms
    3 - Outland
    4 - Northrend
    5 - The Maelstrom
    6 - Pandaria
    7 - Draenor

--]]

function Mounty_Mount(mountid)
	if (MOUNTY_BUILD < 60) then
		CallCompanion("MOUNT", mountid);
	else
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_BUILD = |r"..MOUNTY_BUILD);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> C_MountJournal.Summon("..mountid..") |r");
		C_MountJournal.Summon(mountid);
	end
end

function Mounty_Dismount()
	if (MOUNTY_BUILD < 60) then
		DismissCompanion("MOUNT");
	else
		C_MountJournal.Dismiss();
	end
end

function Mounty_GetNumMounts()
	local returnvalue
	if (MOUNTY_BUILD < 60) then
		returnvalue = GetNumCompanions("MOUNT");
	else
		returnvalue = C_MountJournal.GetNumMounts();
	end
	return returnvalue;
end

function Mounty_GetMountInfo(i)
	local ID, ctn, spellID, icon, issummoned;
	if (MOUNTY_BUILD < 60) then
		ID, ctn, spellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
	else
		ID = 0;
		ctn, spellID, icon, issummoned = C_MountJournal.GetMountInfo(i);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_BUILD = |r"..MOUNTY_BUILD);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> i = |r"..i);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> ID = |r"..ID);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> ctn = |r"..ctn);
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> spellID = |r"..spellID);

	end
	return ID, ctn, spellID, icon, issummoned;
end

function Mounty_SetMap()
	Mounty_GetMap();
	if not MOUNTY.AddMap then
		MOUNTY.AddMap = {};
		MOUNTY.AddMap[0] = {
			[0] = 0;
		};
	end
	if not MOUNTY.AddMap[0] then
		MOUNTY.AddMap[0] = {
			[0] = 0;
		};
	end
	for c,cc in pairs(MOUNTY.MAP) do
		if not MOUNTY.AddMap[c] then
			MOUNTY.AddMap[c] = {
				[0] = 0;
			};
		end
	end
end

function Mounty_GetMap()
	local problem = false;
	local temp = {GetMapContinents()};
	local continents = temp;
	local zones = {};
	local counter = 0;
	if(MOUNTY_WOWBUILD == "6.0.3") then
		local c, n = 0, 0;
		for z,zz in pairs(temp) do
			c = c + 1;
		end
		counter = c;
		if(c > 7) then
			counter = 0;
			problem = true;
			continents = nil;
			continents = {};
			for t=1,c do
				n = n + 1;
				if (n == 2) then
					counter = counter +1;
					continents[counter] = temp[t];
					n = 0;
				end
			end
		end
	end
	local CONT = counter;
	MOUNTY.MAP[-1] = {};
	MOUNTY.MAP[-1][0] = "Cosmic Map";
	MOUNTY.MAP[0] = {};
	MOUNTY.MAP[0][0] = "Azeroth";
	for cid=1,CONT do
		MOUNTY.MAP[cid] = {};
		MOUNTY.MAP[cid][0] = continents[cid];
		temp = nil;
		zones = nil;
		temp = {GetMapZones(cid)};
		zones = temp;
		z=0;
		for a,aa in pairs(temp) do
			z = z + 1;
		end
		counter = z;
		if problem then
			counter = 0;
			zones = nil;
			zones = {};
			n = 0;
			for t=1,z do
				n = n + 1;
				if (n == 2) then
					counter = counter +1;
					zones[counter] = temp[t];
					n = 0;
				end
			end
		end
		for z,zz in pairs(zones) do
			MOUNTY.MAP[cid][z] = zz;
		end
	end
end

function Mounty_GetMapZone()
	local realZone = GetRealZoneText();
	local MAP = MOUNTY.MAP;
	local ADD = MOUNTY.AddMap;
	local exists = false;
	local contexists = false;

	SetMapToCurrentZone();
	local contNum = GetCurrentMapContinent();
	if(MAP[contNum][0]) then
		continent = MAP[contNum][0];
		contexists = true;
	else
		contexists = false;
		contNum = 0;
		continent = MAP[contNum][0];
	end
	local zoneNum = 0;
	local zone = "Unknown";
	local counter, x = 0,0;
	if contexists then
		for z,zz in pairs(MAP[contNum]) do
			if z > counter then
				counter = z;
			end
			if(realZone == zz) then
				exists = true;
				zoneNum = z;
				zone = realZone;
			end
		end
		if not exists then
			for z=1, ADD[contNum][0] do
				if(realZone == ADD[contNum][z]) then
					exists = true;
				end
			end
			if not exists then
				zoneNum = counter + 1;
				MAP[contNum][zoneNum] = realZone;
				zone = MAP[contNum][zoneNum];
				x = ADD[contNum][0] + 1;
				ADD[contNum][x] = zone;
				ADD[contNum][0] = x;
			end
		end
	else
		for c,cc in pairs(MAP) do
			for z,zz in pairs(cc) do
				if(realZone == zz) then
					exists = true;
					zoneNum = z;
					zone = realZone;
					contNum = c;
					continent = MAP[c][0];
				end
			end
		end
		if not exists then
					zoneNum = 0;
					zone = "Unknown";
					contNum = -2;
					continent = "Unknown";
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00Continent / Index is Unknown.|r");
		end
	end
	MOUNTY.MAP = MAP;
	MOUNTY.AddMap = ADD;

	return contNum, continent, zoneNum, zone;
end

function Mounty_603Continent(zone)
	if(MOUNTY_WOWBUILD == "6.0.3") then
		if (zone == 485) then
			zone = "Draenor";
		end
		if (zone == "Outland") then
			zone = "Pandaria";
		end
		if (zone == 466) then
			zone = "The Maelstrom";
		end
		if (zone == "Eastern") then
			zone = "Northrend";
		end
		if (zone == "Eastern Kingdoms") then
			zone = "Northrend";
		end
		if (zone == 14) then
			zone = "Outland";
		end
		if (zone == "Kalimdor") then
			zone = "Eastern Kingdoms";
		end
		if (zone == 13) then
			zone = "Kalimdor";
		end
	end

	return zone;
end

function Mounty_Stables(Ability)
	local buildID = -1;
	local rank = nil;
	GARRISON_Buildings = nil;
	GARRISON_Buildings = C_Garrison.GetBuildings();
	for i,v in pairs(GARRISON_Buildings) do
		for ii,vv in pairs(v) do
			local s = nil;
			local s = string.find(v.texPrefix, "Stables");
			if(s) then buildID = v.buildingID; end
		end
	end
	if(buildID < 0) then
		Ability.printout.Stables = 0;
	else
		local buildingID, buildingName, texturePrefix, icon, description, rank, currencyID, currencyAmount, goldAmount, timeRequirement, needsPlan, isPreBuilt, possSpecs, upgrades, canUpgrade, isMaxLevel, hasFollowerSlot = C_Garrison.GetBuildingInfo(buildID);
		Ability.printout.Stables = rank;
	end
	if(Ability.printout.Stables == 3) then 
		Ability.Skill.Stables = true;
	end
	return Ability;
end

--------------------------------------------------------------------------------------------------------------------------------
-- Imported and converted/edited from Livestock (c)2008 by Scott Snowman (Recompense on Uldum(US))
-- Many thanks for helping accomplish this task!
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_AddMountList(name, spellID)
	local returnName = name;
	local returnvalue = 1;
	local flying = false;
	local changes = false;
	local depend = false;
	local seahorse = false;
--	GameTooltip_SetDefaultAnchor(MountyToolTip, UIParent)
	MountyToolTip:SetOwner(UIParent, "ANCHOR_NONE")
	MountyToolTip:SetHyperlink("spell:"..spellID) -- pull up the tooltip object we created and set it to the ID of the spell
	for i = 1, MountyToolTip:NumLines() do -- iterate over the number of lines in the tooltip
		local text = _G["MountyToolTipTextLeft"..i]:GetText() -- get the text from each line
		if(i == 1) then
			returnName = text;
		end
		for word in string.gmatch(text, "%S+") do -- look at each word in the line.  NOT %a+ because that apparently doesn't capture unicode characters, for the localized clients.
			if strfind(word, "flying") then
				flying = true
			end	
			if strfind(word, "depend") then
				depend = true
			end	
			if strfind(word, "changes") then
				changes = true
			end	
			if strfind(word, MOUNTY_VASHJ_TEXT) then
				seahorse = true -- seahorse mounts also have the word "Vashj'ir" in them
			end
		end
	end -- parse the tooltip.  The variables outland, northrend, very, fast, location, and changes are set to true if the corresponding text is found
	MountyToolTip:Hide(); -- hide our dummy tooltip
	
	returnvalue = 1;
	if flying then -- Flying Mount 
		returnvalue = 2;
	end
	if depend then -- Riding/Flying Mount
		returnvalue = 3;
	end
	if changes then -- Riding/Flying Mount
		returnvalue = 3;
	end
	if seahorse then -- Vashjir Only Swimming Mount 
		returnvalue = 5;
	end
	return returnvalue, returnName;
end

